Unit MLC26_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MLC22_p;

procedure MLC26(var A :Array of Integer; var B :Array of Integer;
                M :Integer; var MU :Integer);

implementation

procedure MLC26(var A :Array of Integer; var B :Array of Integer;
                M :Integer; var MU :Integer);
var
I :Integer;
EPS,RMU :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100;
begin
{   BCEHE MU }
EPS := 1.E-10;
for I:=1 to M do
 begin
  if ( A[I-1] <>  0 ) 
   then goto _20;
  if ( B[I-1] <>  0 ) 
   then goto _90;
_10:
 end;
goto _90;
_20:
RMU := B[I-1]/A[I-1];
MLC22(RMU,MU,EPS);
if ( MU =  1 ) 
 then goto _100;
if ( MU*A[I-1] <>  B[I-1] ) 
 then goto _100;
_30:
I := I + 1;
if ( I >  M ) 
 then goto _100;
if ( A[I-1] ) < 0
 then goto _40
 else if ( A[I-1] ) > 0
       then goto _80
       else goto _70;
_40:
if ( B[I-1] >=  0 ) 
 then goto _100;
_50:
if ( A[I-1]*MU - B[I-1] ) < 0
 then goto _100
 else if ( A[I-1]*MU - B[I-1] ) > 0
       then goto _60
       else goto _30;
_60:
MU := MU - 1;
goto _100;
_70:
if ( B[I-1] ) < 0
 then goto _60
 else if ( B[I-1] ) > 0
       then goto _100
       else goto _30;
_80:
if ( B[I-1] <=  0 ) 
 then goto _60;
goto _50;
_90:
MU := 0;
_100:
end;

end.
