Unit MLC2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MLC21_p, MLC22_p, MLC23_p, MLC24_p, MLC25_p, MLC27_p;

procedure MLC2R(var A :Array of Integer; M :Integer;
                N :Integer; var MR :Array of Integer;
                MAX :Integer; EPS :Real; var IERR :Integer);

implementation

procedure MLC2R(var A :Array of Integer; M :Integer;
                N :Integer; var MR :Array of Integer;
                MAX :Integer; EPS :Real; var IERR :Integer);
var
I,I1,IAI,IAS,IS_,IS1,ITER,J,K,K0,M1,N1,S,V :Integer;
R,RLD :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100;
begin
IS_ := 1;
IERR := 0;
IS1 := N + 1;
IAS := IS1 + N;
IAI := IAS + M;
ITER := 0;
M1 := M - 1;
N1 := N - 1;
for I:=1 to N1 do
 begin
  MR[I-1] := I + 1;
_10:
 end;
MLC25(A,MR[IS_-1],M,N,N1,MAX);
_20:
ITER := ITER + 1;
for I:=2 to M1 do
 begin
  if ( A[(I-1)+0*M] <  0 ) 
   then goto _40;
_30:
 end;
goto _100;
{      B CYAE YXOA O METKE  - MEEM OTMAHOE }
{      EOCEHHOE PEEHE }
_40:
V := I;
{      V-A CTPOKA-POBOA }
MLC21(A,M,N,MR[IS_-1],K,V);
if ( K =  0 ) 
 then goto _90;
if ( K =  1 ) 
 then goto _60;
K0 := K;
for I:=1 to K do
 begin
  I1 := IS1 + I - 1;
  MR[I1-1] := MR[I-1];
_50:
 end;
MLC23(A,M,N,MR[IS_-1],K,S);
MLC27(A,MR[IAS-1],MR[IAI-1],MR[IS1-1],M,N,M1,K0,RLD,V,S);
goto _70;
_60:
S := MR[K-1];
RLD := -A[(V-1)+(S-1)*M];
_70:
for J:=1 to N do
 begin
  R := A[(V-1)+(J-1)*M]/RLD;
  MLC22(R,A[(M-1)+(J-1)*M],EPS);
_80:
 end;
{      M1-A CTPOKA-OTCEEHE OMOPI }
MLC24(A,M,N,M,S);
goto _20;
_90:
IERR := 65;
_100:
end;

end.
